package org.greenstone.gatherer.cdm;
import org.greenstone.gatherer.msm.MSMUtils;
import org.w3c.dom.*;
/** For even more confusion this class provides a convience wrapper around an element, to allow it to appear in the <strong>JList</strong> with both name and description. However this class has nothing to do with its namesake.
 * @see org.greenstone.gatherer.msm.ElementWrapper
 */
public class ElementWrapper
	 implements Comparable {
	 /** The element as the data from this object. */
	 private Node element = null;
	 /** Constructor.
	  * @param element The <strong>Node</strong> this object is wrapped around.
	  */
	 public ElementWrapper(Node element) {
		  this.element = element;
	 }
	 /** Compare two objects for ordering.
	  * @param object The other <strong>Object</strong> to compare to.
	  * @return An <i>int</i> indicating the ordering as is String.compareTo
	  */
	 public int compareTo(Object object) {
		  if(object == null) {
				return 1;
		  }
		  return toString().compareTo(object.toString());
	 }
	 /** Compare two objects for equality.
	  * @param object The <strong>Object</strong> to compare to.
	  * @return <i>true</i> if the objects are equal, <i>false</i> otherwise.
	  */
	 public boolean equals(Object object) {
		  if(compareTo(object) == 0) {
				return true;
		  }
		  return false;
	 }
	 /** Retrieve the name of the element.
	  * @return The fully qualified name as a <strong>String</strong>.
	  * @see org.greenstone.gatherer.msm.MSMUtils
	  */
	 public String name() {
		  return MSMUtils.getFullName((Element)element);
	 }
	 /** Retrieve a textual representation of this object.
	  * @return A <strong>String</strong>.
	  * @see org.greenstone.gatherer.msm.MSMUtils
	  */
	 public String toString() {
		  return MSMUtils.getIdentifier(element) + ": " + MSMUtils.getDescription(element);
	 }
}
